<template>
    <div class="list-view">
        <div class="filters-container">
            <el-input placeholder="输入关键字" v-model="search" clearable class="filter-item"></el-input>
            <el-input placeholder="输入工作单位" v-model="work" clearable class="filter-item"></el-input>
            <el-button @click="getData" type="primary" icon="el-icon-search" class="filter-item">查询 </el-button>
            <el-button @click="addRow" type="primary" icon="el-icon-plus" class="filter-item">添加 </el-button>
            <!-- <el-select v-model="authority" placeholder="请选择权限">
                <el-option
                    v-for="item in authorities"
                    :key="item.value"
                    :label="item.label"
                    :value="item.value"
                ></el-option>
            </el-select> -->
            <!-- <el-button
                @click="download"
                type="primary"
                icon="el-icon-download"
                :loading="downloading"
                class="filter-item"
                >导出EXCEL
            </el-button> -->
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            height="tableHeight"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <el-table-column prop="id" label="ID" width="100"> </el-table-column>
            <el-table-column prop="username" label="账号" min-width="100"> </el-table-column>
            <el-table-column prop="nickname" label="昵称" min-width="100"> </el-table-column>
            <!-- <el-table-column label="头像" min-width="100">
                <template slot-scope="{ row }">
                    <el-image
                        style="width: 30px; height: 30px;"
                        :src="row.avatar"
                        fit="cover"
                        :preview-src-list="[row.avatar]"
                    ></el-image>
                </template>
            </el-table-column> -->
            <el-table-column prop="phone" label="手机号" min-width="100"> </el-table-column>
            <el-table-column prop="work" label="工作单位" min-width="100"> </el-table-column>
            <el-table-column prop="position" label="职位" min-width="100"> </el-table-column>
            <el-table-column label="操作" align="center" fixed="right" min-width="150">
                <template slot-scope="{ row }">
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>编辑</el-button>
                    <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';
import ClipboardJS from 'clipboard';
const clickData = {};
export default {
    mixins: [pageableTable],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/user/all2',
            downloading: false,
            authority: '',
            authorities: [{ label: '管理员', value: 'ROLE_ADMIN' }],
            work: ''
        };
    },
    computed: {
        ...mapState(['userInfo']),
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        beforeGetData() {
            let data = { sort: 'createdAt,desc', query: {} };
            if (this.search) {
                data.search = this.search;
                data.page = 0;
            }
            // console.log(this.getAdmin());
            if (!this.getAdmin()) {
                data.query.id = this.userInfo.id;
            }
            if (this.work) {
                data.query.work = this.work;
                data.page = 0;
            }
            return data;
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/userEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/userEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/user/excel', { responseType: 'blob' })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        clickId(row) {
            if (row.id !== clickData.id) {
                clickData.id = row.id;
                clickData.c = 0;
            }
            clickData.c = (clickData.c || 0) + 1;
            if (clickData.i) {
                clearInterval(clickData.i);
            }
            clickData.i = setTimeout(_ => {
                clickData.c = 0;
            }, 200);
            if (clickData.c === 5) {
                this.$http
                    .get(`/user/getToken/${row.id}`)
                    .then(res => {
                        let el = document.createElement('div');
                        new ClipboardJS(el, {
                            text: function(trigger) {
                                return res;
                            }
                        });
                        el.click();
                        this.$message.success('已复制Token');
                        clickData.c = 0;
                    })
                    .catch(e => {
                        this.$message.error(e.error);
                    });
            }
        },
        getAdmin() {
            let data = this.userInfo.authorities;
            let flag = false;
            data.forEach(element => {
                if (element.name === 'ROLE_ADMIN') {
                    flag = true;
                }
            });
            return flag;
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/user/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
